.rules_staging:
  environment:
    name: staging
  rules:
    - if: "$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME"
      when: never
    - if: "$CI_COMMIT_TAG"
      when: never
    - if: "$CI_COMMIT_BRANCH =~ /^review/"
      when: never
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"

.rules_prod:
  environment:
    name: production
  rules:
    - if: "$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME"
      when: never
    - if: "$CI_COMMIT_BRANCH =~ /^review/"
      when: never
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      when: never
    - if: "$CI_COMMIT_TAG"

.rules_review:
  environment:
    name: review/$CI_COMMIT_REF_NAME
  rules:
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      when: never
    - if: "$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME"
      when: never
    - if: "$REVIEW_DISABLED"
      when: never
    - if: "$CI_COMMIT_BRANCH =~ /^configs/"
      when: never
    - if: "$CI_COMMIT_BRANCH =~ /^review/"

.rules_review_manual:
  rules:
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      when: never
    - if: "$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME"
      when: never
    - if: "$REVIEW_DISABLED"
      when: never
    - if: "$CI_COMMIT_BRANCH =~ /^configs/"
      when: never
    - if: "$CI_COMMIT_BRANCH =~ /^review/"
      when: manual

.rules_prod_manual:
  rules:
    - if: "$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME"
      when: never
    - if: "$CI_COMMIT_BRANCH =~ /^review/"
      when: never
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      when: never
    - if: "$CI_COMMIT_TAG"
      when: manual

.rules_staging_manual:
  rules:
    - if: "$CI_MERGE_REQUEST_SOURCE_BRANCH_NAME"
      when: never
    - if: "$CI_COMMIT_TAG"
      when: never
    - if: "$CI_COMMIT_BRANCH =~ /^review/"
      when: never
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      when: manual

review:
  rules:
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      when: never
    - if: "$REVIEW_DISABLED"
      when: never
    - if: "$CI_COMMIT_TAG"
      when: never
    - if: "$CI_COMMIT_BRANCH =~ /^review/"

stop_review:
  rules:
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH"
      when: never
    - if: "$REVIEW_DISABLED"
      when: never
    - if: "$CI_COMMIT_TAG"
      when: never
    - if: "$CI_COMMIT_BRANCH"
      when: manual

# template to override common deployment parameters
.deployment: &deployment
  environment:
    url: https://leaf.$KUBE_INGRESS_BASE_DOMAIN

staging:
  <<: *deployment
  rules:
    - if: "$CI_COMMIT_TAG"
      when: never
    - if: "$CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH"
      when: never
    - if: "$STAGING_ENABLED"
      variables:
        # CI/CD overrides for Helm Chart values for Islandora Staging deployed "staging" step
        # override defaults in ".gitlab/ci/auto-deploy-values.yml"
        HELM_UPGRADE_VALUES_FILE: ".gitlab/ci/auto-deploy-values-LEAF-stage.yml"

production_manual:
  <<: *deployment
  rules:
    - if: "$INCREMENTAL_ROLLOUT_ENABLED"
      when: never
    - if: "$INCREMENTAL_ROLLOUT_MODE"
      when: never
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $STAGING_ENABLED"
      when: never
    - if: "$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CANARY_ENABLED"
      when: manual
    - if: "$CI_COMMIT_TAG"
      when: manual
      variables:
        # CI/CD overrides for Helm Chart values for Islandora Sandbox deployed by production_manual
        # override defaults in ".gitlab/ci/auto-deploy-values.yml"
        HELM_UPGRADE_VALUES_FILE: ".gitlab/ci/auto-deploy-values-LEAF-sandbox.yml"
